const HiddenServiceConnector = require('./HiddenServiceConnector');
const base32 = require('../utils/base32');

test('base32 decode', function() {
  const decoded = base32.decode('duskgytldkxiuqc6');
  //const decoded_buf = Array.prototype.map.call(decoded, (_, i) => decoded.charCodeAt(i))
  expect(decoded).toEqual(Buffer.from([0x1d,0x24,0xa3,0x62,0x6b,0x1a,0xae,0x8a,0x40,0x5e]));
})
test('base32 encode', function() {
  const encoded = base32.encode(Buffer.from([0x1d,0x24,0xa3,0x62,0x6b,0x1a,0xae,0x8a,0x40,0x5e]));
  //const decoded_buf = Array.prototype.map.call(decoded, (_, i) => decoded.charCodeAt(i))
  expect(encoded).toEqual('duskgytldkxiuqc6');
})
test('test descriptor', function() {
  const time = 1611534264;
  const onion = 'duskgytldkxiuqc6';
  const sut = new HiddenServiceConnector(null, onion, null);
  sut._time = () => time;
  const descriptor = sut.get_descriptor_id(0);
  const descriptor_base32 = base32.encode(descriptor);
  expect(descriptor_base32).toBe('ek7vymlparcwqimmmfixlbars4xjz5jl');
})
